import random
from model.memory import load_dreams
from model.trainer import train_on_message
from model.dynamic_expand import expand_model_if_needed


def replay_dreams():
    expand_model_if_needed()

    dreams = load_dreams()
    if not dreams:
        return

    selected = random.sample(dreams, min(len(dreams), 5))
    for dream in selected:
        text = dream["sentence"]
        if text:
            train_on_message(text)
